#include <io.h>
#include <signal.h>

#include "sendir.h"  

#define SENDIR_HIGH   P1OUT |= 0x01;
#define SENDIR_LOW    P1OUT &= 0xFE;

volatile void sendIRHigh(void);
volatile void sendIRLow(void);

// testroutine which repetedly sends two commands
volatile void testSendIR(){
  volatile unsigned int i;
  for(;;){   
    sendIRData(0xF010);
    for(i=0; i<0xFFFF; i++) nop(); 
    sendIRData(0xF011);
    for(i=0; i<0xFFFF; i++) nop();
  }
}

// sends the lower 12 bits of data via IR, turns interrupt off while it's sending
volatile void sendIRData(int data){
  volatile int mask = 0x2000;
  data |= 0xF000;
  
  dint();
  while(mask != 0){
    if(!(mask & data)){
      sendIRHigh();
      sendIRLow();
    } else {
      sendIRLow();
      sendIRHigh();
    }
    mask /= 2;
  }
  eint();
}

// sends a logical one via IR, method is timed for the 2.4576Mhz SMCLK!!!
volatile void sendIRHigh(void){
    volatile int i;
    for(i=0; i<34; i++){
      SENDIR_HIGH;
      SENDIR_HIGH;
      SENDIR_HIGH;
      SENDIR_HIGH;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;////
    }  
}

// sends a logical 0 via IR, method is timed for the 2.4576Mhz SMCLK!!!
volatile void sendIRLow(void){
    volatile int i;
    for(i=0; i<34; i++){
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
      SENDIR_LOW;
    }  
}
